
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
abstract interface Subject {
	public void attach (ObserverProxy ob);
	public void notifyObservers () ;
}



class NumSubject implements Subject {
	private LinkedList observers = new LinkedList();
	private ListIterator obIter;
	private int state;
	
	public int getState() { return state; }
	
	public void attach(ObserverProxy ob) { observers.add(ob); }

	
	public void setState (int newNum) { state = newNum; notifyObservers(); }
	
	public void notifyObservers () {
	  obIter = observers.listIterator(0);
	  while(obIter.hasNext()) { ((ObserverProxy)obIter.next()).update(state); }
	}
}

public class NetworkObserverSubject {
   public static NumSubject S = new NumSubject();
   public static ObserverProxy OP1 = new ObserverProxy(S, 1);
   public static ObserverProxy OP2 = new ObserverProxy(S, 2);
   public static ObserverProxy OP3 = new ObserverProxy(S, 3);
}
